char dozwolony(char trescw) {
    if(!((trescw>='a' && trescw<='z') ||
	(trescw>='A' && trescw<='Z') ||
	(trescw>='0' && trescw<='9') ||
	(trescw=='(') ||
	(trescw==')') ||
	(trescw=='!') ||
	(trescw=='@') ||
	(trescw=='#') ||
	(trescw=='%') ||
	(trescw=='*') ||
	(trescw==',') ||
	(trescw=='.') ||
	(trescw==' ') ||
	(trescw=='-') ||
	(trescw==';') ||
	(trescw==39) ||
	(trescw=='~') ||
	(trescw==':') ||
	(trescw=='"') ||
	(trescw=='?') ||
	(trescw=='/')
	)) //dozwolone: "!@#%(),.;'~:"?/"
	    trescw='_';
    return trescw;
    }

char warthex(char *i) {
int valu=0;
if(i[1]>='0' && i[1]<='9')
    valu+=(i[1]-48)*16;
else valu+=(toupper(i[1])-55)*16;
if(i[2]>='0' && i[2]<='9')
    valu+=(i[2]-48);
else valu+=(toupper(i[2])-55);
return (char)valu;
}

/*
dekodowanie wap->ekg
*/

int decode(char *liniap, int max) {
int k=0,i;
char linia[1000],liniaw[1001];
    if(strlen(liniap)>1000)
	return 0;
    for(i=0;i<strlen(liniap);i++) {
	if(liniap[i]=='+')linia[k++]=' ';
	else {
	    if(liniap[i]!='%') {
		linia[k++]=liniap[i];
		}
	    else {
		char oc=warthex(liniap+i);
		if(oc!=0)
		    linia[k++]=oc;
		i+=2;
		}
	    }
	}
    linia[k]=0;
    sprintf(liniaw,"%.1000s",linia);
    
/*
dekodowanie polskich znakow wap->ekg (utf-8 -> iso-8859-2)
zgodnie z tabela z nokii 7650
 =  %01%04  =  %01%05  =  %01%06  =  %01%07  =  %01%18  =  %01%19
 =  %01%41  =  %01%42  =  %01%43  =  %01%44  =  %D3     =  %F3
 =  %01%5A  =  %01%5B  =  %01%7B  =  %01%7C  =  %01%79  =  %01%7A
*/

    k=0;
    for(i=0;i<strlen(liniaw);i++) {
	if(liniaw[i]==(char)0xd3)linia[k++]=(nopl)?'O':'';else
	if(liniaw[i]==(char)0xf3)linia[k++]=(nopl)?'o':'';else
	if(liniaw[i]==(char)1) {
	    if(i<(strlen(liniaw)-1))i++;
	    if(liniaw[i]==(char)0x04)linia[k++]=(nopl)?'A':'';else
	    if(liniaw[i]==(char)0x05)linia[k++]=(nopl)?'a':'';else
	    if(liniaw[i]==(char)0x06)linia[k++]=(nopl)?'C':'';else
	    if(liniaw[i]==(char)0x07)linia[k++]=(nopl)?'c':'';else
	    if(liniaw[i]==(char)0x18)linia[k++]=(nopl)?'E':'';else
	    if(liniaw[i]==(char)0x19)linia[k++]=(nopl)?'E':'';else
	    if(liniaw[i]==(char)0x41)linia[k++]=(nopl)?'L':'';else
	    if(liniaw[i]==(char)0x42)linia[k++]=(nopl)?'l':'';else
	    if(liniaw[i]==(char)0x43)linia[k++]=(nopl)?'N':'';else
	    if(liniaw[i]==(char)0x44)linia[k++]=(nopl)?'n':'';else
	    if(liniaw[i]==(char)0x5a)linia[k++]=(nopl)?'S':'';else
	    if(liniaw[i]==(char)0x5b)linia[k++]=(nopl)?'s':'';else
	    if(liniaw[i]==(char)0x7b)linia[k++]=(nopl)?'Z':'';else
	    if(liniaw[i]==(char)0x7c)linia[k++]=(nopl)?'z':'';else
	    if(liniaw[i]==(char)0x79)linia[k++]=(nopl)?'Z':'';else
	    if(liniaw[i]==(char)0x7a)linia[k++]=(nopl)?'z':'';else
	    linia[k++]='_';
	    }
	else
	    linia[k++]=dozwolony(liniaw[i]);
	}
    linia[k]=0;
    
    sprintf(liniap,"%.*s",max-1,linia);
    return 0;
    }

int decodeqp(char *liniap, int max)
{
int k=0,i;
char linia[5000];
if(strlen(liniap)>5000)
    return 0;
for(i=0;i<strlen(liniap);i++) {
    if(liniap[i]!='=') {
	linia[k++]=liniap[i];
    } else {
	if(i!=strlen(liniap)-1) {
	    linia[k++]=warthex(liniap+i);
	    i+=2;
	}
    }
}
linia[k]=0;
sprintf(liniap,"%.*s",max-1,linia);
return 0;
}

int decodesubiect(char *liniap, int max)
{
int k=0,i,qp=0;
char linia[5000];
if(strlen(liniap)>5000)
    return 0;
for(i=0;i<strlen(liniap);i++) {
    if(liniap[i]=='?' && liniap[i+1]=='=' && qp==1) {
	qp=0;
	i+=2;
    }
    else
    if(liniap[i]!='=') {
	linia[k++]=liniap[i];
    } 
    else
    if(strncasecmp(liniap+i,"=?ISO-8859-2?Q?",15)==0) {
	qp=1;
	i+=14;
    }
    else
    if(qp!=1)
	linia[k++]='=';
    else {
	linia[k++]=warthex(liniap+i);
	i+=2;
    }
}
linia[k]=0;
sprintf(liniap,"%.*s",max-1,linia);
return 0;
}

// przetwarza string liniap kodujc lub usuwajc znaczki
// jak=1 jak=0 - normalny tekst
// jak=2 - kasuje rowniez zawartosc w tag-ah dla content: text/html, zaczyna od wyswietlania
// jak=3 - kasuje html, zaczyna od niewyswietlania
// zwraca wskaznik kontynuacji html 1-wyswetlam 0-nie wyswietlam

int dozwolonys(char *liniap, int jak)
{
int i;
int jx=1;
char linia[4000];
if(strlen(liniap)>4000)
    return 0;
linia[0]=0;

if(jak==3) {
    jx=0;
    jak=2;
    };

for(i=0;i<strlen(liniap);i++) {

    if(liniap[i]=='<') {
	if(jak==2)jx=0;
	else sprintf(linia,"%s&#x3C;",linia);
	} else
    if(liniap[i]=='>') {
	if(jak==2)jx=1;
	else sprintf(linia,"%s&#x3E;",linia);
	} else
    
    if(jx==1) {
	if(strncmp(liniap+i,"&nbsp;",6)==0) {
	    sprintf(linia,"%s ",linia);
	    i+=5;
	    } else
	if(liniap[i]=='[')sprintf(linia,"%s&#x5B;",linia);else
	if(liniap[i]==']')sprintf(linia,"%s&#x5D;",linia);else
	if(liniap[i]=='&')sprintf(linia,"%s&#x26;",linia);else
	if(liniap[i]=='=')sprintf(linia,"%s&#x3D;",linia);else
	if(liniap[i]=='*')sprintf(linia,"%s&#x2A;",linia);else
	if(liniap[i]=='')sprintf(linia,"%s%s",linia,(nopl)?"a":"&#261;");else
	if(liniap[i]=='')sprintf(linia,"%s%s",linia,(nopl)?"c":"&#263;");else
	if(liniap[i]=='')sprintf(linia,"%s%s",linia,(nopl)?"e":"&#281;");else
	if(liniap[i]=='')sprintf(linia,"%s%s",linia,(nopl)?"l":"&#322;");else
	if(liniap[i]=='')sprintf(linia,"%s%s",linia,(nopl)?"n":"&#324;");else
	if(liniap[i]=='')sprintf(linia,"%s%s",linia,(nopl)?"o":"&#243;");else
	if(liniap[i]=='')sprintf(linia,"%s%s",linia,(nopl)?"s":"&#347;");else
	if(liniap[i]=='')sprintf(linia,"%s%s",linia,(nopl)?"z":"&#378;");else
	if(liniap[i]=='')sprintf(linia,"%s%s",linia,(nopl)?"z":"&#380;");else
	if(liniap[i]=='')sprintf(linia,"%s%s",linia,(nopl)?"A":"&#260;");else
	if(liniap[i]=='')sprintf(linia,"%s%s",linia,(nopl)?"C":"&#262;");else
	if(liniap[i]=='')sprintf(linia,"%s%s",linia,(nopl)?"E":"&#280;");else
	if(liniap[i]=='')sprintf(linia,"%s%s",linia,(nopl)?"L":"&#321;");else
	if(liniap[i]=='')sprintf(linia,"%s%s",linia,(nopl)?"N":"&#323;");else
	if(liniap[i]=='')sprintf(linia,"%s%s",linia,(nopl)?"O":"&#211;");else
	if(liniap[i]=='')sprintf(linia,"%s%s",linia,(nopl)?"S":"&#346;");else
	if(liniap[i]=='')sprintf(linia,"%s%s",linia,(nopl)?"Z":"&#377;");else
	if(liniap[i]=='')sprintf(linia,"%s%s",linia,(nopl)?"Z":"&#379;");else
	sprintf(linia,"%s%c",linia,dozwolony(liniap[i]));
	}
    }
sprintf(liniap,"%s",linia);
return jx;
}
